#import "XeeIFFReader.h"


@implementation XeeIFFReader

-(id)initWithFilename:(NSString *)filename filetype:(iff_id)filetype
{
	if(self=[super init])
	{
		fh=fopen([filename fileSystemRepresentation],"rb");
		if(fh)
		{
			iff_id fileid=[self readLong];
			filesize=[self readLong]+8;
			iff_id typeid=[self readLong];

			fseek(fh,0,SEEK_END);
			int realsize=ftell(fh);
			if(realsize<filesize) filesize=realsize;

			if(fileid=='FORM'&&typeid==filetype)
			{
				nextchunk=12;
				currid=0;
				currsize=0;

				return self;
			}
		}

		[self release];
	}

	return nil;
}

-(void)dealloc
{
	if(fh) fclose(fh);

	[super dealloc];
}

-(iff_id)nextChunk
{
	if(nextchunk>=filesize) return 0;

	fseek(fh,nextchunk,SEEK_SET);
	currid=[self readLong];
	currsize=[self readLong];
	nextchunk+=8+((currsize+1)&~1);

	return currid;
}

-(iff_id)currentChunk { return currid; }

-(int)chunkSize { return currsize; }

-(int)bytesLeft { return nextchunk-ftell(fh); }

-(unsigned char)readByte
{
	return fgetc(fh);
}

-(unsigned short)readWord
{
	unsigned char b1=fgetc(fh);
	unsigned char b2=fgetc(fh);

	return (b1<<8)|b2;
}

-(unsigned long)readLong
{
	unsigned char b1=fgetc(fh);
	unsigned char b2=fgetc(fh);
	unsigned char b3=fgetc(fh);
	unsigned char b4=fgetc(fh);

	return (b1<<24)|(b2<<16)|(b3<<8)|b4;
}

-(NSData *)readBytes:(int)bytes
{
	int currpos=ftell(fh);
	if(currpos+bytes>nextchunk) bytes=nextchunk-currpos;

	NSMutableData *data=[NSMutableData dataWithLength:bytes];
	int realsize=fread([data mutableBytes],1,bytes,fh);
	if(realsize!=bytes) [data setLength:realsize];

	return data;
}

-(NSData *)readChunk
{
	return [self readBytes:[self bytesLeft]];
}

@end
